Use [CI_SQLGroup_Demo]
GO

DBCC DropCleanBuffers;
DBCC FreeProcCache;

Set Statistics IO on;
Set Statistics TIme on;

Select	A.[OrderDateKey]
		, Sum(A.[SalesAmount]) As Total_Sales
From	[dbo].[FactResellerSalesBig] A 
			Inner Join
		[dbo].[DimDate] B
			On A.OrderDateKey = B.DateKey
Where  B.DateKey < 20070501
Group by A.OrderDateKey;

--physicsal reads 14, read-ahead reads 2583
--cpu: 77ms
--Elaps time: 318 ms


--Second Query
Select	C.ResellerName
		, Sum(A.[SalesAmount]) As Total_Sales
From	[dbo].[FactResellerSalesBig] A 
			Inner Join
		[dbo].[DimDate] B
			On A.OrderDateKey = B.DateKey
			Inner Join
		[dbo].[DimResellerBig] C
			On A.ResellerKey = C.ResellerKey
Where  B.DateKey > 20071201
		And C.NumberEmployees >= 50
Group by C.ResellerName
Order by Total_Sales Desc










--Scalar Count with Columnstore Index
Select	Count(*)
From	[dbo].[FactResellerSalesBig];


--Scalar Count Query rewrite to use Batch mode
With CTE
As
(
Select		OrderDateKey, Count(*) As MyCount
From		[dbo].[FactResellerSalesBig]
Group By	OrderDateKey
)

Select	Sum(MyCount)
From	CTE;


DBCC TraceOn(646,-1);
go
DBCC TraceOn(3605,-1);
go

dbcc tracestatus
go

--Segments elimination test

Select	A.[OrderDateKey]
		, Sum(A.[SalesAmount]) As Total_Sales
From	[dbo].[FactResellerSalesBig] A 
			Inner Join
		[dbo].[DimDate] B
			On A.OrderDateKey = B.DateKey
Where  B.DateKey < 20070501
Group by A.OrderDateKey;

--physicsal reads 14, read-ahead reads 2583
--cpu: 77ms
--Elaps time: 318 ms
Go


Select	B.BusinessType
		, Sum(A.[SalesAmount]) As Total_Sales
From	[dbo].[FactResellerSalesBig] A 
			Inner Join
		[dbo].[DimResellerBig] B
			On A.ResellerKey = B.ResellerKey
Group by B.BusinessType
Order by B.BusinessType;



Select	Count(Distinct ResellerKey)
, Count(Distinct [ProductKey])
From	[dbo].[FactResellerSalesBig] A 





Exec sp_cycle_errorlog;
Go
Exec sp_readerrorlog 0


DBCC TraceOff(646,-1);
DBCC TraceOff(3605,-1);
--DBCC TraceOff(3604,-1);

Set Statistics IO Off;
Set Statistics TIme Off;