Use [CI_SQLGroup_Demo]
GO

DBCC DropCleanBuffers;
DBCC FreeProcCache;

Set Statistics IO on;
Set Statistics TIme on;

Select	A.[OrderDateKey]
		, Sum(A.[SalesAmount]) As Total_Sales
From	[dbo].[FactResellerSalesBig] A 
			Inner Join
		[dbo].[DimDate] B
			On A.OrderDateKey = B.DateKey
Where  B.DateKey < 20070501
Group by A.OrderDateKey
Option (Ignore_Nonclustered_columnstore_Index);

--physical reads: 3, read-ahead reads: 149051
------physicsal reads 14, read-ahead reads 2583 (2583 : 149051 = 1 : 58 = 1.7%)
--CPU: 1701 ms
------cpu: 77ms (77 : 1701 = 1 : 22 = 4.5%)
--Elapse time: 26297 ms
------Elaps time: 318 ms (318 : 26297 = 1 : 83 = 1.2%)

If Exists (	Select *
			From sys.indexes
			Where	name = 'idx_Date_Sales_covering'
					And Object_id = Object_id('dbo.FactResellerSalesbig')
			)
	DROP INDEX [idx_Date_Sales_covering] ON [dbo].[FactResellerSalesbig];



Create nonclustered index idx_Date_Sales_covering on [dbo].[FactResellerSalesBig]
	([OrderDateKey] asc) Include (SalesAmount);



Select	C.ResellerName
		, Sum(A.[SalesAmount]) As Total_Sales
From	[dbo].[FactResellerSalesBig] A 
			Inner Join
		[dbo].[DimDate] B
			On A.OrderDateKey = B.DateKey
			Inner Join
		[dbo].[DimResellerBig] C
			On A.ResellerKey = C.ResellerKey
Where  B.DateKey < 20070501
		And C.NumberEmployees >= 50
Group by C.ResellerName 
Order by Total_Sales Desc
Option (Ignore_Nonclustered_columnstore_Index);












--Scalar Count with BTree Indexes
Select	Count(*)
From	[dbo].[FactResellerSalesBig]
Option (Ignore_Nonclustered_columnstore_Index);


--Scalar Count query rewrite
With CTE
As
(
Select		OrderDateKey, Count(*) As MyCount
From		[dbo].[FactResellerSalesBig]
Group By	OrderDateKey
)

Select	Sum(MyCount)
From	CTE
Option (Ignore_Nonclustered_columnstore_Index);


Select	A.[OrderDateKey]
		, Sum(A.[SalesAmount]) As Total_Sales
From	[dbo].[FactResellerSalesBig] A 
			Inner Join
		[dbo].[DimDate] B
			On A.OrderDateKey = B.DateKey
Where  B.DateKey < 20070501
Group by A.OrderDateKey
Option (Ignore_Nonclustered_columnstore_Index);

--physical reads: 3, read-ahead reads: 149051
------physicsal reads 14, read-ahead reads 2583 (2583 : 149051 = 1 : 58 = 1.7%)
--CPU: 1701 ms
------cpu: 77ms (77 : 1701 = 1 : 22 = 4.5%)
--Elapse time: 26297 ms
------Elaps time: 318 ms (318 : 26297 = 1 : 83 = 1.2%)


Select	B.BusinessType
		, Sum(A.[SalesAmount]) As Total_Sales
From	[dbo].[FactResellerSalesBig] A 
			Inner Join
		[dbo].[DimResellerBig] B
			On A.ResellerKey = B.ResellerKey
Group by B.BusinessType
Order by B.BusinessType
Option (Ignore_Nonclustered_columnstore_Index);





Set Statistics IO Off;
Set Statistics TIme Off;