Use [CI_SQLGroup_Demo]
GO


DBCC DropCleanBuffers;
DBCC FreeProcCache;

Set Statistics IO on;
Set Statistics TIme on;

--Scalar Count with Columnstore Index
Select	Count(*)
From	[dbo].[FactResellerSalesBig];


--Scalar Count Query rewrite to use Batch mode
With CTE
As
(
Select		OrderDateKey, Count(*) As MyCount
From		[dbo].[FactResellerSalesBig]
Group By	OrderDateKey
)

Select	Sum(MyCount)
From	CTE;


--Outer join


Select	A.EnglishProductName
		, Sum(B.OrderQuantity) As Total_Sold
From	[dbo].[DimProduct] A
			Left Outer Join
		[dbo].[FactResellerSalesBig] B
			On A.ProductKey = B.ProductKey
Group by A.EnglishProductName
Order by A.EnglishProductName
--Option (Ignore_Nonclustered_columnstore_Index);

With CTE
As
(
Select	A.ProductKey
		, Sum(B.OrderQuantity) As Total_Sold
From	[dbo].[DimProduct] A
			Inner Join
		[dbo].[FactResellerSalesBig] B
			On A.ProductKey = B.ProductKey
Group by A.ProductKey
)

Select A.EnglishProductName
		, Sum(B.Total_Sold) As Total_Sold
From	[dbo].[DimProduct] A
			Left Outer Join
		CTE B
			On A.ProductKey = B.ProductKey
Group by A.EnglishProductName
Order by A.EnglishProductName;




Set Statistics IO Off;
Set Statistics TIme Off;